> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://typeform.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://typeform.ferndocs.com/_mcp/server.

# Create form

POST https://api.typeform.com/forms
Content-Type: application/json

Here's the general structure for requests to create a form:
  - `title`: Title to use for the form.
  - `type`: Type of form.
  - `settings`: Object that specifies form settings and metadata, including the language to use for the form, whether the form is publicly available, the basis for the progress bar, and search engine indexing settings.
  - `cui_settings`: Object that specifies conversation settings, including the avatar and the typing emulation settings.
  - `theme`: Theme to use for the form.
  - `workspace`: Workspace that contains the form.
  - `hidden`: Array of Hidden Fields to use in the form.
  - `variables`: Object that keeps track of total score or price, if you use them in the form.
  - `welcome_screens`: Array of objects that specify settings and properties for the form's welcome screen.
  - `thankyou_screens`: Array of objects that specify settings and properties for the form's thank you screen.
  - `fields`: Array of objects that specify the fields to use in the form and their properties, validations, and attachments.
  - `logic`: Array of Logic Jump objects to use in the form.

Expand the schema below for details about each of these elements. For optional elements, if you don't send a value and the element doesn't have a default value, no attribute will be returned.

Any images you want to use in your form must already exist in your Typeform account. If you try to create a form that includes an image that isn't already in your Typeform account, the response will include an "IMAGE_NOT_FOUND" error. Use the [POST https://api.typeform.com/images](/create/reference/create-image) endpoint to add images to your account.

**NOTE:** It is not possible to inject third-party content into a typeform using the Create API.

Reference: https://typeform.ferndocs.com/documentation/create-api/api-reference/forms/create

## Authentication

- `Authorization` header (bearer token, required) — Bearer token authentication. Tokens can be generated from the user account. Privileges needed may vary.
- `Authorization` header (required) — A string representation of JWT containing at least two parameters: `ctx.user_id` — user's id `ctx.account_id` — user's default account id `ctx.account_uid` — user's default account uid The usage of account_(u)id from JWT is discouraged, user can have access to multiple accounts, every endpoint has to be account aware if it's needed. This JWT must be signed by the appropriate authority.

## Request

### Body (application/json)

This endpoint expects an object.

- `title` (string, required) — Title to use for the typeform.
- `workspace` (FormsPostRequestBodyContentApplicationJsonSchemaWorkspace, required) — URL of the workspace to use for the typeform. If you don't specify a URL for the workspace, Typeform saves the form in the default workspace.
- `cui_settings` (FormsPostRequestBodyContentApplicationJsonSchemaCuiSettings, optional)
- `fields` (list of FormsPostRequestBodyContentApplicationJsonSchemaFieldsItems, optional)
- `hidden` (list of string, optional) — Array of Hidden Fields to use in the form.
- `logic` (list of FormsPostRequestBodyContentApplicationJsonSchemaLogicItems, optional)
- `settings` (FormsPostRequestBodyContentApplicationJsonSchemaSettings, optional)
- `thankyou_screens` (list of FormsPostRequestBodyContentApplicationJsonSchemaThankyouScreensItems, optional)
- `theme` (FormsPostRequestBodyContentApplicationJsonSchemaTheme, optional) — URL of the theme to use for the typeform. If you don't specify a URL for the theme, Typeform applies a new copy of the default theme to the form.
- `type` (enum, optional, default: quiz) — Form type for the typeform.
  - Allowed values: `quiz`, `classification`, `score`, `branching`, `classification_branching`, `score_branching`
- `variables` (FormsPostRequestBodyContentApplicationJsonSchemaVariables, optional)
- `welcome_screens` (list of FormsPostRequestBodyContentApplicationJsonSchemaWelcomeScreensItems, optional)

## Response

### 201

Created

## Types

### FormsPostRequestBodyContentApplicationJsonSchemaWorkspace

URL of the workspace to use for the typeform. If you don't specify a URL for the workspace, Typeform saves the form in the default workspace.

- `href` (string, optional)

### FormsPostRequestBodyContentApplicationJsonSchemaCuiSettings

- `avatar` (string, optional) — URL for the image to use as conversation avatar. Images must already exist in your account---use the image's Typeform URL, such as `"https://images.typeform.com/images/kbn8tc98AHb"`.
- `is_typing_emulation_disabled` (boolean, optional) — Specifies whether to disable the conversation's typing emulation (i.e. the delay between messages, the aim of which is to give the impression there's an actual person on the other side of the conversation). Typing emulation is enabled by default.
- `typing_emulation_speed` (enum, optional) — The pace at which messages appear in a conversation (as long as typing emulation is enabled).
  - Allowed values: `slow`, `medium`, `fast`

### FormsPostRequestBodyContentApplicationJsonSchemaFieldsItems

Reference for properties in a field. The required fields and properties depend on the `type` value.

- `title` (string, required) — Unique name you assign to the field on this form.
- `type` (enum, required) — The type of field.
  - Allowed values: `calendly`, `contact_info`, `date`, `dropdown`, `email`, `file_upload`, `group`, `legal`, `long_text`, `matrix`, `multiple_choice`, `nps`, `number`, `opinion_scale`, `payment`, `phone_number`, `picture_choice`, `ranking`, `rating`, `short_text`, `statement`, `website`, `yes_no`
- `ref` (string, optional) — Readable name you can use to reference the field.
- `properties` (FormsPostRequestBodyContentApplicationJsonSchemaFieldsItems, optional) — Reference for properties in a field. The required fields and properties depend on the `type` value.
- `validations` (FormsPostRequestBodyContentApplicationJsonSchemaFieldsItemsValidations, optional)
- `attachment` (FormsPostRequestBodyContentApplicationJsonSchemaFieldsItemsAttachment, optional) — Allows you to display images and videos. Available for welcome and thank you screens, as well as all fields.
- `layout` (FormsPostRequestBodyContentApplicationJsonSchemaFieldsItemsLayout, optional) — Allows you to position attachment. Available in all fields, Welcome and Thank you screens.

### FormsPostRequestBodyContentApplicationJsonSchemaLogicItems

- `type` (enum, required) — Specifies whether the Logic Jump is based on a question field or Hidden Field.
  - Allowed values: `field`, `hidden`
- `actions` (list of FormsPostRequestBodyContentApplicationJsonSchemaLogicItemsActionsItems, required) — Array of objects that define the Logic Jump's behavior.
- `ref` (string, optional) — Reference to the field that triggers the the Logic Jump.

### FormsPostRequestBodyContentApplicationJsonSchemaSettings

- `language` (enum, optional)
  - Allowed values: `en`, `es`, `ca`, `fr`, `de`, `ru`, `it`, `da`, `pt`, `ch`, `zh`, `nl`, `no`, `uk`, `ja`, `ko`, `hr`, `fi`, `sv`, `pl`, `el`, `hu`, `tr`, `cs`, `et`, `di`
- `is_public` (boolean, optional, default: true) — true if your form is public. Otherwise, false (your form is private).
- `autocomplete_progress` (boolean, optional, default: true) — true to enable saving partial form responses on the client side. Otherwise, false.
- `progress_bar` (enum, optional, default: proportion) — Basis for the progress bar displayed on the screen. Choose "proportion" to show the number of questions answered so far. Choose "percentage" to show the percentage of questions answered so far.
  - Allowed values: `percentage`, `proportion`
- `show_progress_bar` (boolean, optional, default: true) — true to display progress bar on the typeform. Otherwise, false.
- `show_typeform_branding` (boolean, optional, default: true) — true to display Typeform brand on the typeform. false to hide Typeform branding on the typeform. Hiding Typeform branding is available for [Premium accounts](https://help.typeform.com/hc/en-us/articles/360030829332).
- `show_time_to_complete` (boolean, optional, default: true) — true to display estimated time to complete a typeform on Welcome screens, false to hide it. Mutually exclusive with show_number_of_submissions
- `show_number_of_submissions` (boolean, optional, default: false) — true to display number of submissions on Welcome screens, false to hide it. Mutually exclusive with show_time_to_complete
- `show_cookie_consent` (boolean, optional, default: false) — true to request cookie consent to respondents through a banner, false to do not request it.
- `show_question_number` (boolean, optional, default: true) — true to display the question number on each block, false to hide it.
- `show_key_hint_on_choices` (boolean, optional, default: true) — true to display the key hint letters on Multiple Choice, Picture Choice, Legal and Yes/No blocks, false to hide them.
- `hide_navigation` (boolean, optional, default: false) — false to display the navigation arrows in the bottom-right corner of the form, true to hide them
- `meta` (FormsPostRequestBodyContentApplicationJsonSchemaSettingsMeta, optional)
- `redirect_after_submit_url` (string, optional) — URL where the typeform should redirect upon submission.
- `google_analytics` (string, optional) — Google Analytics tracking ID to use for the form.
- `facebook_pixel` (string, optional) — Facebook Pixel tracking ID to use for the form.
- `google_tag_manager` (string, optional) — Google Tag Manager ID to use for the form.
- `milestones` (list of FormsPostRequestBodyContentApplicationJsonSchemaSettingsMilestonesItems, optional) — An array with block references, indicating where each partial submit point is located. Currently, only one partial submit point per form is allowed. If more than one item is sent within the array, the form definition will be rejected. If the status is inactive, there's also a reason.

### FormsPostRequestBodyContentApplicationJsonSchemaThankyouScreensItems

- `title` (string, required) — Title for the thank you screen.
- `ref` (string, optional) — Readable name you can use to reference the thank you screen.
- `type` (enum, optional) — The type of thank you screen.
  - Allowed values: `thankyou_screen`, `url_redirect`
- `properties` (FormsPostRequestBodyContentApplicationJsonSchemaThankyouScreensItems, optional)
- `attachment` (FormsPostRequestBodyContentApplicationJsonSchemaThankyouScreensItemsAttachment, optional) — Allows you to display images and videos. Available for welcome and thank you screens, as well as all fields.
- `layout` (FormsPostRequestBodyContentApplicationJsonSchemaThankyouScreensItemsLayout, optional) — Allows you to position attachment. Available in all fields, Welcome and Thank you screens.

### FormsPostRequestBodyContentApplicationJsonSchemaTheme

URL of the theme to use for the typeform. If you don't specify a URL for the theme, Typeform applies a new copy of the default theme to the form.

- `href` (string, optional)

### FormsPostRequestBodyContentApplicationJsonSchemaVariables

- `price` (double, optional) — Recall Information for tracking the total price of all items users select (for example, for shopping carts, donation campaigns, and payment collections).
- `score` (integer, optional) — Recall Information for keeping score as users answer each question (for example, for quizzes).

### FormsPostRequestBodyContentApplicationJsonSchemaWelcomeScreensItems

- `title` (string, required) — Title for the welcome screen.
- `ref` (string, optional) — Readable name you can use to reference the welcome screen.
- `properties` (FormsPostRequestBodyContentApplicationJsonSchemaWelcomeScreensItems, optional)
- `attachment` (FormsPostRequestBodyContentApplicationJsonSchemaWelcomeScreensItemsAttachment, optional) — Allows you to display images and videos. Available for welcome and thank you screens, as well as all fields.
- `layout` (FormsPostRequestBodyContentApplicationJsonSchemaWelcomeScreensItemsLayout, optional) — Allows you to position attachment. Available in all fields, Welcome and Thank you screens.

### FormsPostRequestBodyContentApplicationJsonSchemaFieldsItemsValidations

- `required` (boolean, optional, default: false) — true if respondents must provide an answer. Otherwise, false. Available for `matrix`, `ranking`, `date`, `dropdown`, `email`, `file_upload`, `legal`, `long_text`, `multiple_choice`, `number`, `opinion_scale`, `payment`, `picture_choice`, `rating`, `short_text`, `website`, `phone_number`, and `yes_no` types.
- `max_length` (integer, optional, default: 0) — Maximum number of characters allowed in the answer. Available for `long_text` and `short_text` types.
- `min_value` (integer, optional, default: 0) — Minimum value allowed in the answer, must be a positive integer. Available for `number` types.
- `max_value` (integer, optional, default: 0) — Maximum value allowed in the answer, must be a positive integer. Available for `number` types.
- `min_selection` (integer, optional, default: 0) — Minimum selections allowed in the answer, must be a positive integer. Available for `ranking`, `multiple_choice` and `picture_choice` types.
- `max_selection` (integer, optional, default: 0) — Maximum selections allowed in the answer, must be a positive integer. Available for `ranking`, `multiple_choice` and `picture_choice` types.

### FormsPostRequestBodyContentApplicationJsonSchemaFieldsItemsAttachment

Allows you to display images and videos. Available for welcome and thank you screens, as well as all fields.

- `type` (enum, optional) — Type of attachment.
  - Allowed values: `image`, `video`
- `href` (string, optional) — URL for the image or video you want to display. Images must already exist in your account---use the image's Typeform URL, such as `"https://images.typeform.com/images/kbn8tc98AHb"`. For videos, use the URL of the supported platforms, `Vimeo`, `YouTube` or `Pexels`.
- `scale` (enum, optional) — Optional parameter for responsively scaling videos. Available only for `"video"` type. Default value is 0.6.
  - Allowed values: `0.4`, `0.6`, `0.8`, `1`
- `properties` (FormsPostRequestBodyContentApplicationJsonSchemaFieldsItemsAttachment, optional) — Allows you to display images and videos. Available for welcome and thank you screens, as well as all fields.

### FormsPostRequestBodyContentApplicationJsonSchemaFieldsItemsLayout

Allows you to position attachment. Available in all fields, Welcome and Thank you screens.

- `type` (enum, optional) — Type of layout.
  - Allowed values: `split`, `wallpaper`, `float`, `stack`
- `placement` (enum, optional) — Position of media for split and float layouts
  - Allowed values: `left`, `right`
- `attachment` (FormsPostRequestBodyContentApplicationJsonSchemaFieldsItemsLayoutAttachment, optional) — Allows you to display images and videos. Available for welcome and thank you screens, as well as all fields.
- `viewport_overrides` (FormsPostRequestBodyContentApplicationJsonSchemaFieldsItemsLayoutViewportOverrides, optional) — Allows you to add layout-specific overrides per viewport (small / large). Available in all fields, Welcome and Thank you screens.

### FormsPostRequestBodyContentApplicationJsonSchemaLogicItemsActionsItems

- `action` (enum, required) — Behavior the Logic Jump will take.
  - Allowed values: `jump`, `add`, `subtract`, `multiply`, `divide`, `set`
- `details` (FormsPostRequestBodyContentApplicationJsonSchemaLogicItemsActionsItemsDetails, required) — Properties that further specify how the Logic Jump will behave.
- `condition` (FormsPostRequestBodyContentApplicationJsonSchemaLogicItemsActionsItemsCondition, required) — Conditions for executing the Logic Jump. Conditions answer the question, "Under what circumstances?" The condition object is the IF statement in your Logic Jump.

### FormsPostRequestBodyContentApplicationJsonSchemaSettingsMeta

- `title` (string, optional) — Title that represents how the typeform is named in the workspace.
- `allow_indexing` (boolean, optional, default: true) — true to allow search engines to index your typeform. Otherwise, false.
- `description` (string, optional) — Description for search engines to display for your typeform.
- `image` (FormsPostRequestBodyContentApplicationJsonSchemaSettingsMetaImage, optional)

### FormsPostRequestBodyContentApplicationJsonSchemaSettingsMilestonesItems

- `field_ref` (string, optional) — Block reference after which "submit and continue" would be shown in the renderer.
- `status` (enum, optional) — Informative, can't be set through API.
  - Allowed values: `active`, `inactive`
- `reason` (enum, optional) — Informative, can't be set through API.
  - Allowed values: `wrong_position`, `incompatible_feature`

### FormsPostRequestBodyContentApplicationJsonSchemaThankyouScreensItemsAttachment

Allows you to display images and videos. Available for welcome and thank you screens, as well as all fields.

- `type` (enum, optional) — Type of attachment.
  - Allowed values: `image`, `video`
- `href` (string, optional) — URL for the image or video you want to display. Images must already exist in your account---use the image's Typeform URL, such as `"https://images.typeform.com/images/kbn8tc98AHb"`. For videos, use the URL of the supported platforms, `Vimeo`, `YouTube` or `Pexels`.
- `scale` (enum, optional) — Optional parameter for responsively scaling videos. Available only for `"video"` type. Default value is 0.6.
  - Allowed values: `0.4`, `0.6`, `0.8`, `1`
- `properties` (FormsPostRequestBodyContentApplicationJsonSchemaThankyouScreensItemsAttachment, optional) — Allows you to display images and videos. Available for welcome and thank you screens, as well as all fields.

### FormsPostRequestBodyContentApplicationJsonSchemaThankyouScreensItemsLayout

Allows you to position attachment. Available in all fields, Welcome and Thank you screens.

- `type` (enum, optional) — Type of layout.
  - Allowed values: `split`, `wallpaper`, `float`, `stack`
- `placement` (enum, optional) — Position of media for split and float layouts
  - Allowed values: `left`, `right`
- `attachment` (FormsPostRequestBodyContentApplicationJsonSchemaThankyouScreensItemsLayoutAttachment, optional) — Allows you to display images and videos. Available for welcome and thank you screens, as well as all fields.
- `viewport_overrides` (FormsPostRequestBodyContentApplicationJsonSchemaThankyouScreensItemsLayoutViewportOverrides, optional) — Allows you to add layout-specific overrides per viewport (small / large). Available in all fields, Welcome and Thank you screens.

### FormsPostRequestBodyContentApplicationJsonSchemaWelcomeScreensItemsAttachment

Allows you to display images and videos. Available for welcome and thank you screens, as well as all fields.

- `type` (enum, optional) — Type of attachment.
  - Allowed values: `image`, `video`
- `href` (string, optional) — URL for the image or video you want to display. Images must already exist in your account---use the image's Typeform URL, such as `"https://images.typeform.com/images/kbn8tc98AHb"`. For videos, use the URL of the supported platforms, `Vimeo`, `YouTube` or `Pexels`.
- `scale` (enum, optional) — Optional parameter for responsively scaling videos. Available only for `"video"` type. Default value is 0.6.
  - Allowed values: `0.4`, `0.6`, `0.8`, `1`
- `properties` (FormsPostRequestBodyContentApplicationJsonSchemaWelcomeScreensItemsAttachment, optional) — Allows you to display images and videos. Available for welcome and thank you screens, as well as all fields.

### FormsPostRequestBodyContentApplicationJsonSchemaWelcomeScreensItemsLayout

Allows you to position attachment. Available in all fields, Welcome and Thank you screens.

- `type` (enum, optional) — Type of layout.
  - Allowed values: `split`, `wallpaper`, `float`, `stack`
- `placement` (enum, optional) — Position of media for split and float layouts
  - Allowed values: `left`, `right`
- `attachment` (FormsPostRequestBodyContentApplicationJsonSchemaWelcomeScreensItemsLayoutAttachment, optional) — Allows you to display images and videos. Available for welcome and thank you screens, as well as all fields.
- `viewport_overrides` (FormsPostRequestBodyContentApplicationJsonSchemaWelcomeScreensItemsLayoutViewportOverrides, optional) — Allows you to add layout-specific overrides per viewport (small / large). Available in all fields, Welcome and Thank you screens.

### FormsPostRequestBodyContentApplicationJsonSchemaFieldsItemsLayoutAttachment

Allows you to display images and videos. Available for welcome and thank you screens, as well as all fields.

- `type` (enum, optional) — Type of attachment.
  - Allowed values: `image`, `video`
- `href` (string, optional) — URL for the image or video you want to display. Images must already exist in your account---use the image's Typeform URL, such as `"https://images.typeform.com/images/kbn8tc98AHb"`. For videos, use the URL of the supported platforms, `Vimeo`, `YouTube` or `Pexels`.
- `scale` (enum, optional) — Optional parameter for responsively scaling videos. Available only for `"video"` type. Default value is 0.6.
  - Allowed values: `0.4`, `0.6`, `0.8`, `1`
- `properties` (FormsPostRequestBodyContentApplicationJsonSchemaFieldsItemsLayoutAttachment, optional) — Allows you to display images and videos. Available for welcome and thank you screens, as well as all fields.

### FormsPostRequestBodyContentApplicationJsonSchemaFieldsItemsLayoutViewportOverrides

Allows you to add layout-specific overrides per viewport (small / large). Available in all fields, Welcome and Thank you screens.

- `small` (FormsPostRequestBodyContentApplicationJsonSchemaFieldsItemsLayoutViewportOverridesSmall, optional) — Allows you to add layout-specific overrides for small viewports.
- `large` (FormsPostRequestBodyContentApplicationJsonSchemaFieldsItemsLayoutViewportOverridesLarge, optional) — Allows you to add layout-specific overrides for large viewports.

### FormsPostRequestBodyContentApplicationJsonSchemaLogicItemsActionsItemsDetails

Properties that further specify how the Logic Jump will behave.

- `to` (FormsPostRequestBodyContentApplicationJsonSchemaLogicItemsActionsItemsDetailsTo, optional) — Specifies where the Logic Jump leads---to another field ("field"), a thank you screen ("thankyou") or an outcome ("outcome").
- `target` (FormsPostRequestBodyContentApplicationJsonSchemaLogicItemsActionsItemsDetailsTarget, optional) — Keeps a running total for variables.
- `value` (FormsPostRequestBodyContentApplicationJsonSchemaLogicItemsActionsItemsDetailsValue, optional) — Specifies the value to use in the calculation for the variables.

### FormsPostRequestBodyContentApplicationJsonSchemaLogicItemsActionsItemsCondition

Conditions for executing the Logic Jump. Conditions answer the question, "Under what circumstances?" The condition object is the IF statement in your Logic Jump.

- `op` (enum, required) — Operator for the condition.
  - Allowed values: `begins_with`, `ends_with`, `contains`, `not_contains`, `lower_than`, `lower_equal_than`, `greater_than`, `greater_equal_than`, `is`, `is_not`, `equal`, `not_equal`, `always`, `on`, `not_on`, `earlier_than`, `earlier_than_or_on`, `later_than`, `later_than_or_on`
- `vars` (list of FormsPostRequestBodyContentApplicationJsonSchemaLogicItemsActionsItemsConditionVarsItems, required) — Object that defines the field type and value to evaluate with the operator.

### FormsPostRequestBodyContentApplicationJsonSchemaSettingsMetaImage

- `href` (string, optional) — URL of image for search engines to display for your typeform.

### FormsPostRequestBodyContentApplicationJsonSchemaThankyouScreensItemsLayoutAttachment

Allows you to display images and videos. Available for welcome and thank you screens, as well as all fields.

- `type` (enum, optional) — Type of attachment.
  - Allowed values: `image`, `video`
- `href` (string, optional) — URL for the image or video you want to display. Images must already exist in your account---use the image's Typeform URL, such as `"https://images.typeform.com/images/kbn8tc98AHb"`. For videos, use the URL of the supported platforms, `Vimeo`, `YouTube` or `Pexels`.
- `scale` (enum, optional) — Optional parameter for responsively scaling videos. Available only for `"video"` type. Default value is 0.6.
  - Allowed values: `0.4`, `0.6`, `0.8`, `1`
- `properties` (FormsPostRequestBodyContentApplicationJsonSchemaThankyouScreensItemsLayoutAttachment, optional) — Allows you to display images and videos. Available for welcome and thank you screens, as well as all fields.

### FormsPostRequestBodyContentApplicationJsonSchemaThankyouScreensItemsLayoutViewportOverrides

Allows you to add layout-specific overrides per viewport (small / large). Available in all fields, Welcome and Thank you screens.

- `small` (FormsPostRequestBodyContentApplicationJsonSchemaThankyouScreensItemsLayoutViewportOverridesSmall, optional) — Allows you to add layout-specific overrides for small viewports.
- `large` (FormsPostRequestBodyContentApplicationJsonSchemaThankyouScreensItemsLayoutViewportOverridesLarge, optional) — Allows you to add layout-specific overrides for large viewports.

### FormsPostRequestBodyContentApplicationJsonSchemaWelcomeScreensItemsLayoutAttachment

Allows you to display images and videos. Available for welcome and thank you screens, as well as all fields.

- `type` (enum, optional) — Type of attachment.
  - Allowed values: `image`, `video`
- `href` (string, optional) — URL for the image or video you want to display. Images must already exist in your account---use the image's Typeform URL, such as `"https://images.typeform.com/images/kbn8tc98AHb"`. For videos, use the URL of the supported platforms, `Vimeo`, `YouTube` or `Pexels`.
- `scale` (enum, optional) — Optional parameter for responsively scaling videos. Available only for `"video"` type. Default value is 0.6.
  - Allowed values: `0.4`, `0.6`, `0.8`, `1`
- `properties` (FormsPostRequestBodyContentApplicationJsonSchemaWelcomeScreensItemsLayoutAttachment, optional) — Allows you to display images and videos. Available for welcome and thank you screens, as well as all fields.

### FormsPostRequestBodyContentApplicationJsonSchemaWelcomeScreensItemsLayoutViewportOverrides

Allows you to add layout-specific overrides per viewport (small / large). Available in all fields, Welcome and Thank you screens.

- `small` (FormsPostRequestBodyContentApplicationJsonSchemaWelcomeScreensItemsLayoutViewportOverridesSmall, optional) — Allows you to add layout-specific overrides for small viewports.
- `large` (FormsPostRequestBodyContentApplicationJsonSchemaWelcomeScreensItemsLayoutViewportOverridesLarge, optional) — Allows you to add layout-specific overrides for large viewports.

### FormsPostRequestBodyContentApplicationJsonSchemaFieldsItemsLayoutViewportOverridesSmall

Allows you to add layout-specific overrides for small viewports.

- `type` (enum, optional) — Type of layout.
  - Allowed values: `split`, `wallpaper`, `float`, `stack`
- `placement` (enum, optional) — Position of media for split and float layouts.
  - Allowed values: `left`, `right`

### FormsPostRequestBodyContentApplicationJsonSchemaFieldsItemsLayoutViewportOverridesLarge

Allows you to add layout-specific overrides for large viewports.

- `type` (enum, optional) — Type of layout.
  - Allowed values: `split`, `wallpaper`, `float`, `stack`
- `placement` (enum, optional) — Position of media for split and float layouts.
  - Allowed values: `left`, `right`

### FormsPostRequestBodyContentApplicationJsonSchemaLogicItemsActionsItemsDetailsTo

Specifies where the Logic Jump leads---to another field ("field"), a thank you screen ("thankyou") or an outcome ("outcome").

- `type` (enum, required) — Logic Jump "to" option you are using.
  - Allowed values: `field`, `thankyou`, `outcome`
- `value` (string, required) — The "ref" value for the field, Hidden Field, or thank you screen the Logic Jump leads to.

### FormsPostRequestBodyContentApplicationJsonSchemaLogicItemsActionsItemsDetailsTarget

Keeps a running total for variables.

- `type` (enum, required) — Specifies that the value is a variable.
  - Allowed values: `variable`
- `value` (string, required) — Variable name to use in the calculation.

### FormsPostRequestBodyContentApplicationJsonSchemaLogicItemsActionsItemsDetailsValue

Specifies the value to use in the calculation for the variables.

- `type` (enum, required) — Specifies which type of value is used.---It can be a numeric value, a variable name or an `evaluation` to determine an `outcome`.
  - Allowed values: `constant`, `variable`, `evaluation`
- `value` (FormsPostRequestBodyContentApplicationJsonSchemaLogicItemsActionsItemsDetailsValueValue, required) — Value used in the variable calculation.

### FormsPostRequestBodyContentApplicationJsonSchemaLogicItemsActionsItemsConditionVarsItems

- `type` (enum, required) — Type of value the condition object refers to.
  - Allowed values: `field`, `hidden`, `variable`, `constant`, `choice`
- `value` (FormsPostRequestBodyContentApplicationJsonSchemaLogicItemsActionsItemsConditionVarsItemsValue, required) — Value to check for in the "type" field to evaluate with the operator.

### FormsPostRequestBodyContentApplicationJsonSchemaThankyouScreensItemsLayoutViewportOverridesSmall

Allows you to add layout-specific overrides for small viewports.

- `type` (enum, optional) — Type of layout.
  - Allowed values: `split`, `wallpaper`, `float`, `stack`
- `placement` (enum, optional) — Position of media for split and float layouts.
  - Allowed values: `left`, `right`

### FormsPostRequestBodyContentApplicationJsonSchemaThankyouScreensItemsLayoutViewportOverridesLarge

Allows you to add layout-specific overrides for large viewports.

- `type` (enum, optional) — Type of layout.
  - Allowed values: `split`, `wallpaper`, `float`, `stack`
- `placement` (enum, optional) — Position of media for split and float layouts.
  - Allowed values: `left`, `right`

### FormsPostRequestBodyContentApplicationJsonSchemaWelcomeScreensItemsLayoutViewportOverridesSmall

Allows you to add layout-specific overrides for small viewports.

- `type` (enum, optional) — Type of layout.
  - Allowed values: `split`, `wallpaper`, `float`, `stack`
- `placement` (enum, optional) — Position of media for split and float layouts.
  - Allowed values: `left`, `right`

### FormsPostRequestBodyContentApplicationJsonSchemaWelcomeScreensItemsLayoutViewportOverridesLarge

Allows you to add layout-specific overrides for large viewports.

- `type` (enum, optional) — Type of layout.
  - Allowed values: `split`, `wallpaper`, `float`, `stack`
- `placement` (enum, optional) — Position of media for split and float layouts.
  - Allowed values: `left`, `right`

### FormsPostRequestBodyContentApplicationJsonSchemaLogicItemsActionsItemsDetailsValueValue

Value used in the variable calculation.

- double
- string
- FormsPostRequestBodyContentApplicationJsonSchemaLogicItemsActionsItemsDetailsValueValue2

### FormsPostRequestBodyContentApplicationJsonSchemaLogicItemsActionsItemsConditionVarsItemsValue

Value to check for in the "type" field to evaluate with the operator.

### FormsPostRequestBodyContentApplicationJsonSchemaLogicItemsActionsItemsDetailsValueValue2

Evaluation of possible outcomes

- `op` (enum, optional) — operator representing outcome evaluation
  - Allowed values: `max_outcome`
- `vars` (list of FormsPostRequestBodyContentApplicationJsonSchemaLogicItemsActionsItemsDetailsValueValueOneOf2VarsItems, optional)

### FormsPostRequestBodyContentApplicationJsonSchemaLogicItemsActionsItemsDetailsValueValueOneOf2VarsItems

outcome to evaluate

- `type` (enum, optional)
  - Allowed values: `outcome`
- `value` (string, optional) — outcome reference

## Examples

**Request**

```json
{
  "title": "This is an example form",
  "workspace": {
    "href": "https://api.typeform.com/workspaces/Aw33bz"
  },
  "cui_settings": {
    "avatar": "https://images.typeform.com/images/4BKUhw8A9cSM"
  },
  "fields": [
    {
      "title": "Date Title",
      "type": "date",
      "ref": "nice_readable_date_reference",
      "properties": {
        "description": "Cool description for the date",
        "structure": "DDMMYYYY",
        "separator": "-"
      },
      "validations": {
        "required": false
      },
      "attachment": {
        "type": "video",
        "href": "https://www.youtube.com/watch?v=Uui3oT-XBxs",
        "scale": 0.8,
        "properties": {
          "description": "Typeform Home documentary"
        }
      }
    },
    {
      "title": "Dropdown Title",
      "type": "dropdown",
      "ref": "nice_readable_dropdown_reference",
      "properties": {
        "description": "Cool description for the dropdown",
        "choices": [
          {
            "label": "Foo"
          },
          {
            "label": "Bar"
          }
        ],
        "randomize": false,
        "alphabetical_order": false
      },
      "validations": {
        "required": false
      },
      "layout": {
        "type": "float",
        "placement": "right",
        "attachment": {
          "type": "image",
          "href": "https://images.typeform.com/images/4BKUhw8A9cSM"
        }
      }
    },
    {
      "title": "Email Title",
      "type": "email",
      "ref": "nice_readable_email_reference",
      "properties": {
        "description": "Cool description for the email"
      },
      "validations": {
        "required": false
      },
      "attachment": {
        "type": "video",
        "href": "https://www.youtube.com/watch?v=Uui3oT-XBxs",
        "scale": 0.8
      }
    },
    {
      "title": "File Upload Title",
      "type": "file_upload",
      "ref": "nice_readable_file_upload_reference",
      "properties": {
        "description": "Cool description for the file upload"
      },
      "validations": {
        "required": false
      }
    },
    {
      "title": "Legal Title",
      "type": "legal",
      "ref": "nice_readable_legal_reference",
      "properties": {
        "description": "Cool description for the legal"
      },
      "validations": {
        "required": false
      }
    },
    {
      "title": "Long Text Title",
      "type": "long_text",
      "ref": "nice_readable_long_text_reference",
      "properties": {
        "description": "Cool description for the long text"
      },
      "validations": {
        "required": false,
        "max_length": 20
      },
      "layout": {
        "type": "wallpaper",
        "attachment": {
          "type": "image",
          "href": "https://images.typeform.com/images/4BKUhw8A9cSM"
        },
        "viewport_overrides": {
          "large": {
            "type": "float",
            "placement": "left"
          }
        }
      }
    },
    {
      "title": "Multiple Choice Title",
      "type": "multiple_choice",
      "ref": "nice_readable_multiple_choice_reference",
      "properties": {
        "description": "Cool description for the multiple choice",
        "choices": [
          {
            "ref": "foo_choice_ref",
            "label": "Foo"
          },
          {
            "ref": "bar_choice_ref",
            "label": "Bar"
          }
        ],
        "allow_multiple_selection": false,
        "randomize": true,
        "allow_other_choice": true,
        "vertical_alignment": false
      },
      "validations": {
        "required": false
      },
      "attachment": {
        "type": "video",
        "href": "https://www.youtube.com/watch?v=Uui3oT-XBxs",
        "scale": 0.8
      }
    },
    {
      "title": "Ranking Title",
      "type": "ranking",
      "ref": "nice_readable_ranking_reference",
      "properties": {
        "description": "Description for the ranking",
        "choices": [
          {
            "ref": "foo_choice_ref",
            "label": "Foo"
          },
          {
            "ref": "bar_choice_ref",
            "label": "Bar"
          }
        ],
        "allow_multiple_selection": false,
        "randomize": true
      },
      "validations": {
        "required": false
      }
    },
    {
      "title": "Number Title",
      "type": "number",
      "ref": "nice_readable_number_reference",
      "properties": {
        "description": "Cool description for the number"
      },
      "validations": {
        "required": false,
        "min_value": 20,
        "max_value": 50
      },
      "attachment": {
        "type": "image",
        "href": "https://images.typeform.com/images/4BKUhw8A9cSM",
        "properties": {
          "description": "A beautiful sunset",
          "decorative": false
        }
      }
    },
    {
      "title": "Opinion Scale Title",
      "type": "opinion_scale",
      "ref": "nice_readable_opinion_scale_reference",
      "properties": {
        "description": "Cool description for the opinion scale field",
        "steps": 9,
        "labels": {
          "left": "left label",
          "right": "right label",
          "center": "center label"
        },
        "start_at_one": true
      },
      "validations": {
        "required": false
      },
      "attachment": {
        "type": "video",
        "href": "https://www.youtube.com/watch?v=Uui3oT-XBxs",
        "scale": 0.8
      }
    },
    {
      "title": "Picture Choice Title",
      "type": "picture_choice",
      "ref": "nice_readable_picture_choice_reference",
      "properties": {
        "description": "Cool description for the picture choice",
        "choices": [
          {
            "ref": "foo_choice_ref1",
            "label": "Foo 1",
            "attachment": {
              "type": "image",
              "href": "https://images.typeform.com/images/4BKUhw8A9cSM",
              "properties": {
                "description": "A sports car"
              }
            }
          },
          {
            "ref": "foo_choice_ref2",
            "label": "Foo 2",
            "attachment": {
              "type": "image",
              "href": "https://images.typeform.com/images/4BKUhw8A9cSM",
              "properties": {
                "description": "A pickup truck"
              }
            }
          }
        ],
        "allow_multiple_selection": false,
        "randomize": true,
        "allow_other_choice": true,
        "supersized": false,
        "show_labels": false
      },
      "validations": {
        "required": false
      }
    },
    {
      "title": "Rating Title",
      "type": "rating",
      "ref": "nice_readable_rating_reference",
      "properties": {
        "description": "Cool description for the rating",
        "steps": 10,
        "shape": "star"
      },
      "validations": {
        "required": false
      },
      "attachment": {
        "type": "video",
        "href": "https://www.youtube.com/watch?v=Uui3oT-XBxs",
        "scale": 0.8
      }
    },
    {
      "title": "Short Text Title",
      "type": "short_text",
      "ref": "nice_readable_short_text_reference",
      "properties": {
        "description": "Cool description for the short text"
      },
      "validations": {
        "required": false,
        "max_length": 20
      },
      "attachment": {
        "type": "image",
        "href": "https://images.typeform.com/images/4BKUhw8A9cSM",
        "properties": {
          "description": "A beautiful sunset",
          "decorative": false
        }
      }
    },
    {
      "title": "Statement Title",
      "type": "statement",
      "ref": "nice_readable_statement_reference",
      "properties": {
        "description": "Cool description for the statement",
        "hide_marks": true,
        "button_text": "Statement button text"
      },
      "attachment": {
        "type": "video",
        "href": "https://www.youtube.com/watch?v=Uui3oT-XBxs",
        "scale": 0.8
      }
    },
    {
      "title": "Website Title",
      "type": "website",
      "ref": "nice_readable_website_reference",
      "properties": {
        "description": "Cool description for the website"
      },
      "validations": {
        "required": false
      }
    },
    {
      "title": "yes or no",
      "type": "yes_no",
      "ref": "nice_readable_yes_no_reference",
      "properties": {
        "description": "Cool description for the Yes/No question"
      },
      "validations": {
        "required": false
      },
      "attachment": {
        "type": "image",
        "href": "https://images.typeform.com/images/4BKUhw8A9cSM",
        "properties": {
          "decorative": false
        }
      }
    },
    {
      "title": "payment",
      "type": "payment",
      "ref": "nice_readable_payment_reference",
      "properties": {
        "description": "Cool description for the payment group",
        "button_text": "next",
        "currency": "EUR",
        "price": {
          "type": "variable",
          "value": "price"
        },
        "show_button": true
      },
      "validations": {
        "required": false
      },
      "attachment": {
        "type": "image",
        "href": "https://images.typeform.com/images/4BKUhw8A9cSM"
      }
    },
    {
      "title": "group field",
      "type": "group",
      "ref": "a_group_field_ref",
      "properties": {
        "description": "Question group description",
        "fields": [
          "string"
        ],
        "button_text": "Some text",
        "show_button": true
      },
      "attachment": {
        "type": "image",
        "href": "https://images.typeform.com/images/4BKUhw8A9cSM"
      }
    },
    {
      "title": "matrix field",
      "type": "matrix",
      "ref": "a_matrix_field_ref",
      "properties": {
        "description": "Matrix description",
        "fields": [
          "string"
        ]
      }
    },
    {
      "title": "Contact info",
      "type": "contact_info",
      "ref": "a_contact_info_field_ref",
      "properties": {
        "fields": [
          "string",
          "string",
          "string",
          "string",
          "string"
        ]
      },
      "validations": {
        "required": false
      }
    }
  ],
  "hidden": [
    "var1",
    "var2",
    "var3"
  ],
  "logic": [
    {
      "type": "field",
      "actions": [
        {
          "action": "jump",
          "details": {
            "to": {
              "type": "field",
              "value": "nice_readable_rating_reference"
            }
          },
          "condition": {
            "op": "equal",
            "vars": [
              {
                "type": "field",
                "value": "nice_readable_number_reference"
              },
              {
                "type": "constant",
                "value": 5
              }
            ]
          }
        },
        {
          "action": "add",
          "details": {
            "target": {
              "type": "variable",
              "value": "score"
            },
            "value": {
              "type": "constant",
              "value": 5
            }
          },
          "condition": {
            "op": "is",
            "vars": [
              {
                "type": "field",
                "value": "nice_readable_yes_no_reference"
              },
              {
                "type": "constant",
                "value": true
              }
            ]
          }
        }
      ],
      "ref": "nice_readable_yes_no_reference"
    }
  ],
  "settings": {
    "language": "en",
    "is_public": false,
    "progress_bar": "percentage",
    "show_progress_bar": true,
    "show_typeform_branding": false,
    "show_time_to_complete": true,
    "show_number_of_submissions": false,
    "show_cookie_consent": false,
    "show_question_number": true,
    "show_key_hint_on_choices": true,
    "hide_navigation": false,
    "meta": {
      "title": "Meta title",
      "allow_indexing": true,
      "description": "Cool meta description",
      "image": {
        "href": "https://images.typeform.com/images/4BKUhw8A9cSM"
      },
      "canva_design_id": "DAElrx6aq-A"
    },
    "redirect_after_submit_url": "https://www.redirecttohere.com",
    "google_analytics": "UA-1111-22",
    "facebook_pixel": "4347295725729872",
    "google_tag_manager": "GTM-43959999",
    "autosave_progress": true,
    "free_form_navigation": false
  },
  "thankyou_screens": [
    {
      "title": "Thank you Title",
      "ref": "nice-readable-thank-you-ref",
      "properties": {
        "show_button": true,
        "button_text": "start",
        "button_mode": "redirect",
        "redirect_url": "https://www.typeform.com",
        "share_icons": false
      },
      "attachment": {
        "type": "image",
        "href": "https://images.typeform.com/images/4BKUhw8A9cSM"
      }
    }
  ],
  "theme": {
    "href": "https://api.typeform.com/themes/qHWOQ7"
  },
  "type": "quiz",
  "variables": {
    "price": 10.59,
    "score": 0,
    "age": 28,
    "name": "typeform"
  },
  "welcome_screens": [
    {
      "title": "Welcome Title",
      "ref": "nice-readable-welcome-ref",
      "properties": {
        "description": "Cool description for the welcome",
        "show_button": true,
        "button_text": "start"
      },
      "layout": {
        "type": "split",
        "placement": "left",
        "attachment": {
          "type": "image",
          "href": "https://images.typeform.com/images/4BKUhw8A9cSM",
          "properties": {
            "decorative": true
          }
        },
        "viewport_overrides": {
          "small": {
            "type": "wallpaper"
          }
        }
      }
    }
  ]
}
```

**Response**

```json
{}
```

**SDK Code**

```python
import requests

url = "https://api.typeform.com/forms"

payload = {
    "title": "This is an example form",
    "workspace": { "href": "https://api.typeform.com/workspaces/Aw33bz" },
    "cui_settings": { "avatar": "https://images.typeform.com/images/4BKUhw8A9cSM" },
    "fields": [
        {
            "title": "Date Title",
            "type": "date",
            "ref": "nice_readable_date_reference",
            "properties": {
                "description": "Cool description for the date",
                "structure": "DDMMYYYY",
                "separator": "-"
            },
            "validations": { "required": False },
            "attachment": {
                "type": "video",
                "href": "https://www.youtube.com/watch?v=Uui3oT-XBxs",
                "scale": 0.8,
                "properties": { "description": "Typeform Home documentary" }
            }
        },
        {
            "title": "Dropdown Title",
            "type": "dropdown",
            "ref": "nice_readable_dropdown_reference",
            "properties": {
                "description": "Cool description for the dropdown",
                "choices": [{ "label": "Foo" }, { "label": "Bar" }],
                "randomize": False,
                "alphabetical_order": False
            },
            "validations": { "required": False },
            "layout": {
                "type": "float",
                "placement": "right",
                "attachment": {
                    "type": "image",
                    "href": "https://images.typeform.com/images/4BKUhw8A9cSM"
                }
            }
        },
        {
            "title": "Email Title",
            "type": "email",
            "ref": "nice_readable_email_reference",
            "properties": { "description": "Cool description for the email" },
            "validations": { "required": False },
            "attachment": {
                "type": "video",
                "href": "https://www.youtube.com/watch?v=Uui3oT-XBxs",
                "scale": 0.8
            }
        },
        {
            "title": "File Upload Title",
            "type": "file_upload",
            "ref": "nice_readable_file_upload_reference",
            "properties": { "description": "Cool description for the file upload" },
            "validations": { "required": False }
        },
        {
            "title": "Legal Title",
            "type": "legal",
            "ref": "nice_readable_legal_reference",
            "properties": { "description": "Cool description for the legal" },
            "validations": { "required": False }
        },
        {
            "title": "Long Text Title",
            "type": "long_text",
            "ref": "nice_readable_long_text_reference",
            "properties": { "description": "Cool description for the long text" },
            "validations": {
                "required": False,
                "max_length": 20
            },
            "layout": {
                "type": "wallpaper",
                "attachment": {
                    "type": "image",
                    "href": "https://images.typeform.com/images/4BKUhw8A9cSM"
                },
                "viewport_overrides": { "large": {
                        "type": "float",
                        "placement": "left"
                    } }
            }
        },
        {
            "title": "Multiple Choice Title",
            "type": "multiple_choice",
            "ref": "nice_readable_multiple_choice_reference",
            "properties": {
                "description": "Cool description for the multiple choice",
                "choices": [
                    {
                        "ref": "foo_choice_ref",
                        "label": "Foo"
                    },
                    {
                        "ref": "bar_choice_ref",
                        "label": "Bar"
                    }
                ],
                "allow_multiple_selection": False,
                "randomize": True,
                "allow_other_choice": True,
                "vertical_alignment": False
            },
            "validations": { "required": False },
            "attachment": {
                "type": "video",
                "href": "https://www.youtube.com/watch?v=Uui3oT-XBxs",
                "scale": 0.8
            }
        },
        {
            "title": "Ranking Title",
            "type": "ranking",
            "ref": "nice_readable_ranking_reference",
            "properties": {
                "description": "Description for the ranking",
                "choices": [
                    {
                        "ref": "foo_choice_ref",
                        "label": "Foo"
                    },
                    {
                        "ref": "bar_choice_ref",
                        "label": "Bar"
                    }
                ],
                "allow_multiple_selection": False,
                "randomize": True
            },
            "validations": { "required": False }
        },
        {
            "title": "Number Title",
            "type": "number",
            "ref": "nice_readable_number_reference",
            "properties": { "description": "Cool description for the number" },
            "validations": {
                "required": False,
                "min_value": 20,
                "max_value": 50
            },
            "attachment": {
                "type": "image",
                "href": "https://images.typeform.com/images/4BKUhw8A9cSM",
                "properties": {
                    "description": "A beautiful sunset",
                    "decorative": False
                }
            }
        },
        {
            "title": "Opinion Scale Title",
            "type": "opinion_scale",
            "ref": "nice_readable_opinion_scale_reference",
            "properties": {
                "description": "Cool description for the opinion scale field",
                "steps": 9,
                "labels": {
                    "left": "left label",
                    "right": "right label",
                    "center": "center label"
                },
                "start_at_one": True
            },
            "validations": { "required": False },
            "attachment": {
                "type": "video",
                "href": "https://www.youtube.com/watch?v=Uui3oT-XBxs",
                "scale": 0.8
            }
        },
        {
            "title": "Picture Choice Title",
            "type": "picture_choice",
            "ref": "nice_readable_picture_choice_reference",
            "properties": {
                "description": "Cool description for the picture choice",
                "choices": [
                    {
                        "ref": "foo_choice_ref1",
                        "label": "Foo 1",
                        "attachment": {
                            "type": "image",
                            "href": "https://images.typeform.com/images/4BKUhw8A9cSM",
                            "properties": { "description": "A sports car" }
                        }
                    },
                    {
                        "ref": "foo_choice_ref2",
                        "label": "Foo 2",
                        "attachment": {
                            "type": "image",
                            "href": "https://images.typeform.com/images/4BKUhw8A9cSM",
                            "properties": { "description": "A pickup truck" }
                        }
                    }
                ],
                "allow_multiple_selection": False,
                "randomize": True,
                "allow_other_choice": True,
                "supersized": False,
                "show_labels": False
            },
            "validations": { "required": False }
        },
        {
            "title": "Rating Title",
            "type": "rating",
            "ref": "nice_readable_rating_reference",
            "properties": {
                "description": "Cool description for the rating",
                "steps": 10,
                "shape": "star"
            },
            "validations": { "required": False },
            "attachment": {
                "type": "video",
                "href": "https://www.youtube.com/watch?v=Uui3oT-XBxs",
                "scale": 0.8
            }
        },
        {
            "title": "Short Text Title",
            "type": "short_text",
            "ref": "nice_readable_short_text_reference",
            "properties": { "description": "Cool description for the short text" },
            "validations": {
                "required": False,
                "max_length": 20
            },
            "attachment": {
                "type": "image",
                "href": "https://images.typeform.com/images/4BKUhw8A9cSM",
                "properties": {
                    "description": "A beautiful sunset",
                    "decorative": False
                }
            }
        },
        {
            "title": "Statement Title",
            "type": "statement",
            "ref": "nice_readable_statement_reference",
            "properties": {
                "description": "Cool description for the statement",
                "hide_marks": True,
                "button_text": "Statement button text"
            },
            "attachment": {
                "type": "video",
                "href": "https://www.youtube.com/watch?v=Uui3oT-XBxs",
                "scale": 0.8
            }
        },
        {
            "title": "Website Title",
            "type": "website",
            "ref": "nice_readable_website_reference",
            "properties": { "description": "Cool description for the website" },
            "validations": { "required": False }
        },
        {
            "title": "yes or no",
            "type": "yes_no",
            "ref": "nice_readable_yes_no_reference",
            "properties": { "description": "Cool description for the Yes/No question" },
            "validations": { "required": False },
            "attachment": {
                "type": "image",
                "href": "https://images.typeform.com/images/4BKUhw8A9cSM",
                "properties": { "decorative": False }
            }
        },
        {
            "title": "payment",
            "type": "payment",
            "ref": "nice_readable_payment_reference",
            "properties": {
                "description": "Cool description for the payment group",
                "button_text": "next",
                "currency": "EUR",
                "price": {
                    "type": "variable",
                    "value": "price"
                },
                "show_button": True
            },
            "validations": { "required": False },
            "attachment": {
                "type": "image",
                "href": "https://images.typeform.com/images/4BKUhw8A9cSM"
            }
        },
        {
            "title": "group field",
            "type": "group",
            "ref": "a_group_field_ref",
            "properties": {
                "description": "Question group description",
                "fields": ["string"],
                "button_text": "Some text",
                "show_button": True
            },
            "attachment": {
                "type": "image",
                "href": "https://images.typeform.com/images/4BKUhw8A9cSM"
            }
        },
        {
            "title": "matrix field",
            "type": "matrix",
            "ref": "a_matrix_field_ref",
            "properties": {
                "description": "Matrix description",
                "fields": ["string"]
            }
        },
        {
            "title": "Contact info",
            "type": "contact_info",
            "ref": "a_contact_info_field_ref",
            "properties": { "fields": ["string", "string", "string", "string", "string"] },
            "validations": { "required": False }
        }
    ],
    "hidden": ["var1", "var2", "var3"],
    "logic": [
        {
            "type": "field",
            "actions": [
                {
                    "action": "jump",
                    "details": { "to": {
                            "type": "field",
                            "value": "nice_readable_rating_reference"
                        } },
                    "condition": {
                        "op": "equal",
                        "vars": [
                            {
                                "type": "field",
                                "value": "nice_readable_number_reference"
                            },
                            {
                                "type": "constant",
                                "value": 5
                            }
                        ]
                    }
                },
                {
                    "action": "add",
                    "details": {
                        "target": {
                            "type": "variable",
                            "value": "score"
                        },
                        "value": {
                            "type": "constant",
                            "value": 5
                        }
                    },
                    "condition": {
                        "op": "is",
                        "vars": [
                            {
                                "type": "field",
                                "value": "nice_readable_yes_no_reference"
                            },
                            {
                                "type": "constant",
                                "value": True
                            }
                        ]
                    }
                }
            ],
            "ref": "nice_readable_yes_no_reference"
        }
    ],
    "settings": {
        "language": "en",
        "is_public": False,
        "progress_bar": "percentage",
        "show_progress_bar": True,
        "show_typeform_branding": False,
        "show_time_to_complete": True,
        "show_number_of_submissions": False,
        "show_cookie_consent": False,
        "show_question_number": True,
        "show_key_hint_on_choices": True,
        "hide_navigation": False,
        "meta": {
            "title": "Meta title",
            "allow_indexing": True,
            "description": "Cool meta description",
            "image": { "href": "https://images.typeform.com/images/4BKUhw8A9cSM" },
            "canva_design_id": "DAElrx6aq-A"
        },
        "redirect_after_submit_url": "https://www.redirecttohere.com",
        "google_analytics": "UA-1111-22",
        "facebook_pixel": "4347295725729872",
        "google_tag_manager": "GTM-43959999",
        "autosave_progress": True,
        "free_form_navigation": False
    },
    "thankyou_screens": [
        {
            "title": "Thank you Title",
            "ref": "nice-readable-thank-you-ref",
            "properties": {
                "show_button": True,
                "button_text": "start",
                "button_mode": "redirect",
                "redirect_url": "https://www.typeform.com",
                "share_icons": False
            },
            "attachment": {
                "type": "image",
                "href": "https://images.typeform.com/images/4BKUhw8A9cSM"
            }
        }
    ],
    "theme": { "href": "https://api.typeform.com/themes/qHWOQ7" },
    "type": "quiz",
    "variables": {
        "price": 10.59,
        "score": 0,
        "age": 28,
        "name": "typeform"
    },
    "welcome_screens": [
        {
            "title": "Welcome Title",
            "ref": "nice-readable-welcome-ref",
            "properties": {
                "description": "Cool description for the welcome",
                "show_button": True,
                "button_text": "start"
            },
            "layout": {
                "type": "split",
                "placement": "left",
                "attachment": {
                    "type": "image",
                    "href": "https://images.typeform.com/images/4BKUhw8A9cSM",
                    "properties": { "decorative": True }
                },
                "viewport_overrides": { "small": { "type": "wallpaper" } }
            }
        }
    ]
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.typeform.com/forms';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"title":"This is an example form","workspace":{"href":"https://api.typeform.com/workspaces/Aw33bz"},"cui_settings":{"avatar":"https://images.typeform.com/images/4BKUhw8A9cSM"},"fields":[{"title":"Date Title","type":"date","ref":"nice_readable_date_reference","properties":{"description":"Cool description for the date","structure":"DDMMYYYY","separator":"-"},"validations":{"required":false},"attachment":{"type":"video","href":"https://www.youtube.com/watch?v=Uui3oT-XBxs","scale":0.8,"properties":{"description":"Typeform Home documentary"}}},{"title":"Dropdown Title","type":"dropdown","ref":"nice_readable_dropdown_reference","properties":{"description":"Cool description for the dropdown","choices":[{"label":"Foo"},{"label":"Bar"}],"randomize":false,"alphabetical_order":false},"validations":{"required":false},"layout":{"type":"float","placement":"right","attachment":{"type":"image","href":"https://images.typeform.com/images/4BKUhw8A9cSM"}}},{"title":"Email Title","type":"email","ref":"nice_readable_email_reference","properties":{"description":"Cool description for the email"},"validations":{"required":false},"attachment":{"type":"video","href":"https://www.youtube.com/watch?v=Uui3oT-XBxs","scale":0.8}},{"title":"File Upload Title","type":"file_upload","ref":"nice_readable_file_upload_reference","properties":{"description":"Cool description for the file upload"},"validations":{"required":false}},{"title":"Legal Title","type":"legal","ref":"nice_readable_legal_reference","properties":{"description":"Cool description for the legal"},"validations":{"required":false}},{"title":"Long Text Title","type":"long_text","ref":"nice_readable_long_text_reference","properties":{"description":"Cool description for the long text"},"validations":{"required":false,"max_length":20},"layout":{"type":"wallpaper","attachment":{"type":"image","href":"https://images.typeform.com/images/4BKUhw8A9cSM"},"viewport_overrides":{"large":{"type":"float","placement":"left"}}}},{"title":"Multiple Choice Title","type":"multiple_choice","ref":"nice_readable_multiple_choice_reference","properties":{"description":"Cool description for the multiple choice","choices":[{"ref":"foo_choice_ref","label":"Foo"},{"ref":"bar_choice_ref","label":"Bar"}],"allow_multiple_selection":false,"randomize":true,"allow_other_choice":true,"vertical_alignment":false},"validations":{"required":false},"attachment":{"type":"video","href":"https://www.youtube.com/watch?v=Uui3oT-XBxs","scale":0.8}},{"title":"Ranking Title","type":"ranking","ref":"nice_readable_ranking_reference","properties":{"description":"Description for the ranking","choices":[{"ref":"foo_choice_ref","label":"Foo"},{"ref":"bar_choice_ref","label":"Bar"}],"allow_multiple_selection":false,"randomize":true},"validations":{"required":false}},{"title":"Number Title","type":"number","ref":"nice_readable_number_reference","properties":{"description":"Cool description for the number"},"validations":{"required":false,"min_value":20,"max_value":50},"attachment":{"type":"image","href":"https://images.typeform.com/images/4BKUhw8A9cSM","properties":{"description":"A beautiful sunset","decorative":false}}},{"title":"Opinion Scale Title","type":"opinion_scale","ref":"nice_readable_opinion_scale_reference","properties":{"description":"Cool description for the opinion scale field","steps":9,"labels":{"left":"left label","right":"right label","center":"center label"},"start_at_one":true},"validations":{"required":false},"attachment":{"type":"video","href":"https://www.youtube.com/watch?v=Uui3oT-XBxs","scale":0.8}},{"title":"Picture Choice Title","type":"picture_choice","ref":"nice_readable_picture_choice_reference","properties":{"description":"Cool description for the picture choice","choices":[{"ref":"foo_choice_ref1","label":"Foo 1","attachment":{"type":"image","href":"https://images.typeform.com/images/4BKUhw8A9cSM","properties":{"description":"A sports car"}}},{"ref":"foo_choice_ref2","label":"Foo 2","attachment":{"type":"image","href":"https://images.typeform.com/images/4BKUhw8A9cSM","properties":{"description":"A pickup truck"}}}],"allow_multiple_selection":false,"randomize":true,"allow_other_choice":true,"supersized":false,"show_labels":false},"validations":{"required":false}},{"title":"Rating Title","type":"rating","ref":"nice_readable_rating_reference","properties":{"description":"Cool description for the rating","steps":10,"shape":"star"},"validations":{"required":false},"attachment":{"type":"video","href":"https://www.youtube.com/watch?v=Uui3oT-XBxs","scale":0.8}},{"title":"Short Text Title","type":"short_text","ref":"nice_readable_short_text_reference","properties":{"description":"Cool description for the short text"},"validations":{"required":false,"max_length":20},"attachment":{"type":"image","href":"https://images.typeform.com/images/4BKUhw8A9cSM","properties":{"description":"A beautiful sunset","decorative":false}}},{"title":"Statement Title","type":"statement","ref":"nice_readable_statement_reference","properties":{"description":"Cool description for the statement","hide_marks":true,"button_text":"Statement button text"},"attachment":{"type":"video","href":"https://www.youtube.com/watch?v=Uui3oT-XBxs","scale":0.8}},{"title":"Website Title","type":"website","ref":"nice_readable_website_reference","properties":{"description":"Cool description for the website"},"validations":{"required":false}},{"title":"yes or no","type":"yes_no","ref":"nice_readable_yes_no_reference","properties":{"description":"Cool description for the Yes/No question"},"validations":{"required":false},"attachment":{"type":"image","href":"https://images.typeform.com/images/4BKUhw8A9cSM","properties":{"decorative":false}}},{"title":"payment","type":"payment","ref":"nice_readable_payment_reference","properties":{"description":"Cool description for the payment group","button_text":"next","currency":"EUR","price":{"type":"variable","value":"price"},"show_button":true},"validations":{"required":false},"attachment":{"type":"image","href":"https://images.typeform.com/images/4BKUhw8A9cSM"}},{"title":"group field","type":"group","ref":"a_group_field_ref","properties":{"description":"Question group description","fields":["string"],"button_text":"Some text","show_button":true},"attachment":{"type":"image","href":"https://images.typeform.com/images/4BKUhw8A9cSM"}},{"title":"matrix field","type":"matrix","ref":"a_matrix_field_ref","properties":{"description":"Matrix description","fields":["string"]}},{"title":"Contact info","type":"contact_info","ref":"a_contact_info_field_ref","properties":{"fields":["string","string","string","string","string"]},"validations":{"required":false}}],"hidden":["var1","var2","var3"],"logic":[{"type":"field","actions":[{"action":"jump","details":{"to":{"type":"field","value":"nice_readable_rating_reference"}},"condition":{"op":"equal","vars":[{"type":"field","value":"nice_readable_number_reference"},{"type":"constant","value":5}]}},{"action":"add","details":{"target":{"type":"variable","value":"score"},"value":{"type":"constant","value":5}},"condition":{"op":"is","vars":[{"type":"field","value":"nice_readable_yes_no_reference"},{"type":"constant","value":true}]}}],"ref":"nice_readable_yes_no_reference"}],"settings":{"language":"en","is_public":false,"progress_bar":"percentage","show_progress_bar":true,"show_typeform_branding":false,"show_time_to_complete":true,"show_number_of_submissions":false,"show_cookie_consent":false,"show_question_number":true,"show_key_hint_on_choices":true,"hide_navigation":false,"meta":{"title":"Meta title","allow_indexing":true,"description":"Cool meta description","image":{"href":"https://images.typeform.com/images/4BKUhw8A9cSM"},"canva_design_id":"DAElrx6aq-A"},"redirect_after_submit_url":"https://www.redirecttohere.com","google_analytics":"UA-1111-22","facebook_pixel":"4347295725729872","google_tag_manager":"GTM-43959999","autosave_progress":true,"free_form_navigation":false},"thankyou_screens":[{"title":"Thank you Title","ref":"nice-readable-thank-you-ref","properties":{"show_button":true,"button_text":"start","button_mode":"redirect","redirect_url":"https://www.typeform.com","share_icons":false},"attachment":{"type":"image","href":"https://images.typeform.com/images/4BKUhw8A9cSM"}}],"theme":{"href":"https://api.typeform.com/themes/qHWOQ7"},"type":"quiz","variables":{"price":10.59,"score":0,"age":28,"name":"typeform"},"welcome_screens":[{"title":"Welcome Title","ref":"nice-readable-welcome-ref","properties":{"description":"Cool description for the welcome","show_button":true,"button_text":"start"},"layout":{"type":"split","placement":"left","attachment":{"type":"image","href":"https://images.typeform.com/images/4BKUhw8A9cSM","properties":{"decorative":true}},"viewport_overrides":{"small":{"type":"wallpaper"}}}}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.typeform.com/forms"

	payload := strings.NewReader("{\n  \"title\": \"This is an example form\",\n  \"workspace\": {\n    \"href\": \"https://api.typeform.com/workspaces/Aw33bz\"\n  },\n  \"cui_settings\": {\n    \"avatar\": \"https://images.typeform.com/images/4BKUhw8A9cSM\"\n  },\n  \"fields\": [\n    {\n      \"title\": \"Date Title\",\n      \"type\": \"date\",\n      \"ref\": \"nice_readable_date_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the date\",\n        \"structure\": \"DDMMYYYY\",\n        \"separator\": \"-\"\n      },\n      \"validations\": {\n        \"required\": false\n      },\n      \"attachment\": {\n        \"type\": \"video\",\n        \"href\": \"https://www.youtube.com/watch?v=Uui3oT-XBxs\",\n        \"scale\": 0.8,\n        \"properties\": {\n          \"description\": \"Typeform Home documentary\"\n        }\n      }\n    },\n    {\n      \"title\": \"Dropdown Title\",\n      \"type\": \"dropdown\",\n      \"ref\": \"nice_readable_dropdown_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the dropdown\",\n        \"choices\": [\n          {\n            \"label\": \"Foo\"\n          },\n          {\n            \"label\": \"Bar\"\n          }\n        ],\n        \"randomize\": false,\n        \"alphabetical_order\": false\n      },\n      \"validations\": {\n        \"required\": false\n      },\n      \"layout\": {\n        \"type\": \"float\",\n        \"placement\": \"right\",\n        \"attachment\": {\n          \"type\": \"image\",\n          \"href\": \"https://images.typeform.com/images/4BKUhw8A9cSM\"\n        }\n      }\n    },\n    {\n      \"title\": \"Email Title\",\n      \"type\": \"email\",\n      \"ref\": \"nice_readable_email_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the email\"\n      },\n      \"validations\": {\n        \"required\": false\n      },\n      \"attachment\": {\n        \"type\": \"video\",\n        \"href\": \"https://www.youtube.com/watch?v=Uui3oT-XBxs\",\n        \"scale\": 0.8\n      }\n    },\n    {\n      \"title\": \"File Upload Title\",\n      \"type\": \"file_upload\",\n      \"ref\": \"nice_readable_file_upload_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the file upload\"\n      },\n      \"validations\": {\n        \"required\": false\n      }\n    },\n    {\n      \"title\": \"Legal Title\",\n      \"type\": \"legal\",\n      \"ref\": \"nice_readable_legal_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the legal\"\n      },\n      \"validations\": {\n        \"required\": false\n      }\n    },\n    {\n      \"title\": \"Long Text Title\",\n      \"type\": \"long_text\",\n      \"ref\": \"nice_readable_long_text_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the long text\"\n      },\n      \"validations\": {\n        \"required\": false,\n        \"max_length\": 20\n      },\n      \"layout\": {\n        \"type\": \"wallpaper\",\n        \"attachment\": {\n          \"type\": \"image\",\n          \"href\": \"https://images.typeform.com/images/4BKUhw8A9cSM\"\n        },\n        \"viewport_overrides\": {\n          \"large\": {\n            \"type\": \"float\",\n            \"placement\": \"left\"\n          }\n        }\n      }\n    },\n    {\n      \"title\": \"Multiple Choice Title\",\n      \"type\": \"multiple_choice\",\n      \"ref\": \"nice_readable_multiple_choice_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the multiple choice\",\n        \"choices\": [\n          {\n            \"ref\": \"foo_choice_ref\",\n            \"label\": \"Foo\"\n          },\n          {\n            \"ref\": \"bar_choice_ref\",\n            \"label\": \"Bar\"\n          }\n        ],\n        \"allow_multiple_selection\": false,\n        \"randomize\": true,\n        \"allow_other_choice\": true,\n        \"vertical_alignment\": false\n      },\n      \"validations\": {\n        \"required\": false\n      },\n      \"attachment\": {\n        \"type\": \"video\",\n        \"href\": \"https://www.youtube.com/watch?v=Uui3oT-XBxs\",\n        \"scale\": 0.8\n      }\n    },\n    {\n      \"title\": \"Ranking Title\",\n      \"type\": \"ranking\",\n      \"ref\": \"nice_readable_ranking_reference\",\n      \"properties\": {\n        \"description\": \"Description for the ranking\",\n        \"choices\": [\n          {\n            \"ref\": \"foo_choice_ref\",\n            \"label\": \"Foo\"\n          },\n          {\n            \"ref\": \"bar_choice_ref\",\n            \"label\": \"Bar\"\n          }\n        ],\n        \"allow_multiple_selection\": false,\n        \"randomize\": true\n      },\n      \"validations\": {\n        \"required\": false\n      }\n    },\n    {\n      \"title\": \"Number Title\",\n      \"type\": \"number\",\n      \"ref\": \"nice_readable_number_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the number\"\n      },\n      \"validations\": {\n        \"required\": false,\n        \"min_value\": 20,\n        \"max_value\": 50\n      },\n      \"attachment\": {\n        \"type\": \"image\",\n        \"href\": \"https://images.typeform.com/images/4BKUhw8A9cSM\",\n        \"properties\": {\n          \"description\": \"A beautiful sunset\",\n          \"decorative\": false\n        }\n      }\n    },\n    {\n      \"title\": \"Opinion Scale Title\",\n      \"type\": \"opinion_scale\",\n      \"ref\": \"nice_readable_opinion_scale_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the opinion scale field\",\n        \"steps\": 9,\n        \"labels\": {\n          \"left\": \"left label\",\n          \"right\": \"right label\",\n          \"center\": \"center label\"\n        },\n        \"start_at_one\": true\n      },\n      \"validations\": {\n        \"required\": false\n      },\n      \"attachment\": {\n        \"type\": \"video\",\n        \"href\": \"https://www.youtube.com/watch?v=Uui3oT-XBxs\",\n        \"scale\": 0.8\n      }\n    },\n    {\n      \"title\": \"Picture Choice Title\",\n      \"type\": \"picture_choice\",\n      \"ref\": \"nice_readable_picture_choice_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the picture choice\",\n        \"choices\": [\n          {\n            \"ref\": \"foo_choice_ref1\",\n            \"label\": \"Foo 1\",\n            \"attachment\": {\n              \"type\": \"image\",\n              \"href\": \"https://images.typeform.com/images/4BKUhw8A9cSM\",\n              \"properties\": {\n                \"description\": \"A sports car\"\n              }\n            }\n          },\n          {\n            \"ref\": \"foo_choice_ref2\",\n            \"label\": \"Foo 2\",\n            \"attachment\": {\n              \"type\": \"image\",\n              \"href\": \"https://images.typeform.com/images/4BKUhw8A9cSM\",\n              \"properties\": {\n                \"description\": \"A pickup truck\"\n              }\n            }\n          }\n        ],\n        \"allow_multiple_selection\": false,\n        \"randomize\": true,\n        \"allow_other_choice\": true,\n        \"supersized\": false,\n        \"show_labels\": false\n      },\n      \"validations\": {\n        \"required\": false\n      }\n    },\n    {\n      \"title\": \"Rating Title\",\n      \"type\": \"rating\",\n      \"ref\": \"nice_readable_rating_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the rating\",\n        \"steps\": 10,\n        \"shape\": \"star\"\n      },\n      \"validations\": {\n        \"required\": false\n      },\n      \"attachment\": {\n        \"type\": \"video\",\n        \"href\": \"https://www.youtube.com/watch?v=Uui3oT-XBxs\",\n        \"scale\": 0.8\n      }\n    },\n    {\n      \"title\": \"Short Text Title\",\n      \"type\": \"short_text\",\n      \"ref\": \"nice_readable_short_text_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the short text\"\n      },\n      \"validations\": {\n        \"required\": false,\n        \"max_length\": 20\n      },\n      \"attachment\": {\n        \"type\": \"image\",\n        \"href\": \"https://images.typeform.com/images/4BKUhw8A9cSM\",\n        \"properties\": {\n          \"description\": \"A beautiful sunset\",\n          \"decorative\": false\n        }\n      }\n    },\n    {\n      \"title\": \"Statement Title\",\n      \"type\": \"statement\",\n      \"ref\": \"nice_readable_statement_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the statement\",\n        \"hide_marks\": true,\n        \"button_text\": \"Statement button text\"\n      },\n      \"attachment\": {\n        \"type\": \"video\",\n        \"href\": \"https://www.youtube.com/watch?v=Uui3oT-XBxs\",\n        \"scale\": 0.8\n      }\n    },\n    {\n      \"title\": \"Website Title\",\n      \"type\": \"website\",\n      \"ref\": \"nice_readable_website_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the website\"\n      },\n      \"validations\": {\n        \"required\": false\n      }\n    },\n    {\n      \"title\": \"yes or no\",\n      \"type\": \"yes_no\",\n      \"ref\": \"nice_readable_yes_no_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the Yes/No question\"\n      },\n      \"validations\": {\n        \"required\": false\n      },\n      \"attachment\": {\n        \"type\": \"image\",\n        \"href\": \"https://images.typeform.com/images/4BKUhw8A9cSM\",\n        \"properties\": {\n          \"decorative\": false\n        }\n      }\n    },\n    {\n      \"title\": \"payment\",\n      \"type\": \"payment\",\n      \"ref\": \"nice_readable_payment_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the payment group\",\n        \"button_text\": \"next\",\n        \"currency\": \"EUR\",\n        \"price\": {\n          \"type\": \"variable\",\n          \"value\": \"price\"\n        },\n        \"show_button\": true\n      },\n      \"validations\": {\n        \"required\": false\n      },\n      \"attachment\": {\n        \"type\": \"image\",\n        \"href\": \"https://images.typeform.com/images/4BKUhw8A9cSM\"\n      }\n    },\n    {\n      \"title\": \"group field\",\n      \"type\": \"group\",\n      \"ref\": \"a_group_field_ref\",\n      \"properties\": {\n        \"description\": \"Question group description\",\n        \"fields\": [\n          \"string\"\n        ],\n        \"button_text\": \"Some text\",\n        \"show_button\": true\n      },\n      \"attachment\": {\n        \"type\": \"image\",\n        \"href\": \"https://images.typeform.com/images/4BKUhw8A9cSM\"\n      }\n    },\n    {\n      \"title\": \"matrix field\",\n      \"type\": \"matrix\",\n      \"ref\": \"a_matrix_field_ref\",\n      \"properties\": {\n        \"description\": \"Matrix description\",\n        \"fields\": [\n          \"string\"\n        ]\n      }\n    },\n    {\n      \"title\": \"Contact info\",\n      \"type\": \"contact_info\",\n      \"ref\": \"a_contact_info_field_ref\",\n      \"properties\": {\n        \"fields\": [\n          \"string\",\n          \"string\",\n          \"string\",\n          \"string\",\n          \"string\"\n        ]\n      },\n      \"validations\": {\n        \"required\": false\n      }\n    }\n  ],\n  \"hidden\": [\n    \"var1\",\n    \"var2\",\n    \"var3\"\n  ],\n  \"logic\": [\n    {\n      \"type\": \"field\",\n      \"actions\": [\n        {\n          \"action\": \"jump\",\n          \"details\": {\n            \"to\": {\n              \"type\": \"field\",\n              \"value\": \"nice_readable_rating_reference\"\n            }\n          },\n          \"condition\": {\n            \"op\": \"equal\",\n            \"vars\": [\n              {\n                \"type\": \"field\",\n                \"value\": \"nice_readable_number_reference\"\n              },\n              {\n                \"type\": \"constant\",\n                \"value\": 5\n              }\n            ]\n          }\n        },\n        {\n          \"action\": \"add\",\n          \"details\": {\n            \"target\": {\n              \"type\": \"variable\",\n              \"value\": \"score\"\n            },\n            \"value\": {\n              \"type\": \"constant\",\n              \"value\": 5\n            }\n          },\n          \"condition\": {\n            \"op\": \"is\",\n            \"vars\": [\n              {\n                \"type\": \"field\",\n                \"value\": \"nice_readable_yes_no_reference\"\n              },\n              {\n                \"type\": \"constant\",\n                \"value\": true\n              }\n            ]\n          }\n        }\n      ],\n      \"ref\": \"nice_readable_yes_no_reference\"\n    }\n  ],\n  \"settings\": {\n    \"language\": \"en\",\n    \"is_public\": false,\n    \"progress_bar\": \"percentage\",\n    \"show_progress_bar\": true,\n    \"show_typeform_branding\": false,\n    \"show_time_to_complete\": true,\n    \"show_number_of_submissions\": false,\n    \"show_cookie_consent\": false,\n    \"show_question_number\": true,\n    \"show_key_hint_on_choices\": true,\n    \"hide_navigation\": false,\n    \"meta\": {\n      \"title\": \"Meta title\",\n      \"allow_indexing\": true,\n      \"description\": \"Cool meta description\",\n      \"image\": {\n        \"href\": \"https://images.typeform.com/images/4BKUhw8A9cSM\"\n      },\n      \"canva_design_id\": \"DAElrx6aq-A\"\n    },\n    \"redirect_after_submit_url\": \"https://www.redirecttohere.com\",\n    \"google_analytics\": \"UA-1111-22\",\n    \"facebook_pixel\": \"4347295725729872\",\n    \"google_tag_manager\": \"GTM-43959999\",\n    \"autosave_progress\": true,\n    \"free_form_navigation\": false\n  },\n  \"thankyou_screens\": [\n    {\n      \"title\": \"Thank you Title\",\n      \"ref\": \"nice-readable-thank-you-ref\",\n      \"properties\": {\n        \"show_button\": true,\n        \"button_text\": \"start\",\n        \"button_mode\": \"redirect\",\n        \"redirect_url\": \"https://www.typeform.com\",\n        \"share_icons\": false\n      },\n      \"attachment\": {\n        \"type\": \"image\",\n        \"href\": \"https://images.typeform.com/images/4BKUhw8A9cSM\"\n      }\n    }\n  ],\n  \"theme\": {\n    \"href\": \"https://api.typeform.com/themes/qHWOQ7\"\n  },\n  \"type\": \"quiz\",\n  \"variables\": {\n    \"price\": 10.59,\n    \"score\": 0,\n    \"age\": 28,\n    \"name\": \"typeform\"\n  },\n  \"welcome_screens\": [\n    {\n      \"title\": \"Welcome Title\",\n      \"ref\": \"nice-readable-welcome-ref\",\n      \"properties\": {\n        \"description\": \"Cool description for the welcome\",\n        \"show_button\": true,\n        \"button_text\": \"start\"\n      },\n      \"layout\": {\n        \"type\": \"split\",\n        \"placement\": \"left\",\n        \"attachment\": {\n          \"type\": \"image\",\n          \"href\": \"https://images.typeform.com/images/4BKUhw8A9cSM\",\n          \"properties\": {\n            \"decorative\": true\n          }\n        },\n        \"viewport_overrides\": {\n          \"small\": {\n            \"type\": \"wallpaper\"\n          }\n        }\n      }\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.typeform.com/forms")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"title\": \"This is an example form\",\n  \"workspace\": {\n    \"href\": \"https://api.typeform.com/workspaces/Aw33bz\"\n  },\n  \"cui_settings\": {\n    \"avatar\": \"https://images.typeform.com/images/4BKUhw8A9cSM\"\n  },\n  \"fields\": [\n    {\n      \"title\": \"Date Title\",\n      \"type\": \"date\",\n      \"ref\": \"nice_readable_date_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the date\",\n        \"structure\": \"DDMMYYYY\",\n        \"separator\": \"-\"\n      },\n      \"validations\": {\n        \"required\": false\n      },\n      \"attachment\": {\n        \"type\": \"video\",\n        \"href\": \"https://www.youtube.com/watch?v=Uui3oT-XBxs\",\n        \"scale\": 0.8,\n        \"properties\": {\n          \"description\": \"Typeform Home documentary\"\n        }\n      }\n    },\n    {\n      \"title\": \"Dropdown Title\",\n      \"type\": \"dropdown\",\n      \"ref\": \"nice_readable_dropdown_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the dropdown\",\n        \"choices\": [\n          {\n            \"label\": \"Foo\"\n          },\n          {\n            \"label\": \"Bar\"\n          }\n        ],\n        \"randomize\": false,\n        \"alphabetical_order\": false\n      },\n      \"validations\": {\n        \"required\": false\n      },\n      \"layout\": {\n        \"type\": \"float\",\n        \"placement\": \"right\",\n        \"attachment\": {\n          \"type\": \"image\",\n          \"href\": \"https://images.typeform.com/images/4BKUhw8A9cSM\"\n        }\n      }\n    },\n    {\n      \"title\": \"Email Title\",\n      \"type\": \"email\",\n      \"ref\": \"nice_readable_email_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the email\"\n      },\n      \"validations\": {\n        \"required\": false\n      },\n      \"attachment\": {\n        \"type\": \"video\",\n        \"href\": \"https://www.youtube.com/watch?v=Uui3oT-XBxs\",\n        \"scale\": 0.8\n      }\n    },\n    {\n      \"title\": \"File Upload Title\",\n      \"type\": \"file_upload\",\n      \"ref\": \"nice_readable_file_upload_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the file upload\"\n      },\n      \"validations\": {\n        \"required\": false\n      }\n    },\n    {\n      \"title\": \"Legal Title\",\n      \"type\": \"legal\",\n      \"ref\": \"nice_readable_legal_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the legal\"\n      },\n      \"validations\": {\n        \"required\": false\n      }\n    },\n    {\n      \"title\": \"Long Text Title\",\n      \"type\": \"long_text\",\n      \"ref\": \"nice_readable_long_text_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the long text\"\n      },\n      \"validations\": {\n        \"required\": false,\n        \"max_length\": 20\n      },\n      \"layout\": {\n        \"type\": \"wallpaper\",\n        \"attachment\": {\n          \"type\": \"image\",\n          \"href\": \"https://images.typeform.com/images/4BKUhw8A9cSM\"\n        },\n        \"viewport_overrides\": {\n          \"large\": {\n            \"type\": \"float\",\n            \"placement\": \"left\"\n          }\n        }\n      }\n    },\n    {\n      \"title\": \"Multiple Choice Title\",\n      \"type\": \"multiple_choice\",\n      \"ref\": \"nice_readable_multiple_choice_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the multiple choice\",\n        \"choices\": [\n          {\n            \"ref\": \"foo_choice_ref\",\n            \"label\": \"Foo\"\n          },\n          {\n            \"ref\": \"bar_choice_ref\",\n            \"label\": \"Bar\"\n          }\n        ],\n        \"allow_multiple_selection\": false,\n        \"randomize\": true,\n        \"allow_other_choice\": true,\n        \"vertical_alignment\": false\n      },\n      \"validations\": {\n        \"required\": false\n      },\n      \"attachment\": {\n        \"type\": \"video\",\n        \"href\": \"https://www.youtube.com/watch?v=Uui3oT-XBxs\",\n        \"scale\": 0.8\n      }\n    },\n    {\n      \"title\": \"Ranking Title\",\n      \"type\": \"ranking\",\n      \"ref\": \"nice_readable_ranking_reference\",\n      \"properties\": {\n        \"description\": \"Description for the ranking\",\n        \"choices\": [\n          {\n            \"ref\": \"foo_choice_ref\",\n            \"label\": \"Foo\"\n          },\n          {\n            \"ref\": \"bar_choice_ref\",\n            \"label\": \"Bar\"\n          }\n        ],\n        \"allow_multiple_selection\": false,\n        \"randomize\": true\n      },\n      \"validations\": {\n        \"required\": false\n      }\n    },\n    {\n      \"title\": \"Number Title\",\n      \"type\": \"number\",\n      \"ref\": \"nice_readable_number_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the number\"\n      },\n      \"validations\": {\n        \"required\": false,\n        \"min_value\": 20,\n        \"max_value\": 50\n      },\n      \"attachment\": {\n        \"type\": \"image\",\n        \"href\": \"https://images.typeform.com/images/4BKUhw8A9cSM\",\n        \"properties\": {\n          \"description\": \"A beautiful sunset\",\n          \"decorative\": false\n        }\n      }\n    },\n    {\n      \"title\": \"Opinion Scale Title\",\n      \"type\": \"opinion_scale\",\n      \"ref\": \"nice_readable_opinion_scale_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the opinion scale field\",\n        \"steps\": 9,\n        \"labels\": {\n          \"left\": \"left label\",\n          \"right\": \"right label\",\n          \"center\": \"center label\"\n        },\n        \"start_at_one\": true\n      },\n      \"validations\": {\n        \"required\": false\n      },\n      \"attachment\": {\n        \"type\": \"video\",\n        \"href\": \"https://www.youtube.com/watch?v=Uui3oT-XBxs\",\n        \"scale\": 0.8\n      }\n    },\n    {\n      \"title\": \"Picture Choice Title\",\n      \"type\": \"picture_choice\",\n      \"ref\": \"nice_readable_picture_choice_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the picture choice\",\n        \"choices\": [\n          {\n            \"ref\": \"foo_choice_ref1\",\n            \"label\": \"Foo 1\",\n            \"attachment\": {\n              \"type\": \"image\",\n              \"href\": \"https://images.typeform.com/images/4BKUhw8A9cSM\",\n              \"properties\": {\n                \"description\": \"A sports car\"\n              }\n            }\n          },\n          {\n            \"ref\": \"foo_choice_ref2\",\n            \"label\": \"Foo 2\",\n            \"attachment\": {\n              \"type\": \"image\",\n              \"href\": \"https://images.typeform.com/images/4BKUhw8A9cSM\",\n              \"properties\": {\n                \"description\": \"A pickup truck\"\n              }\n            }\n          }\n        ],\n        \"allow_multiple_selection\": false,\n        \"randomize\": true,\n        \"allow_other_choice\": true,\n        \"supersized\": false,\n        \"show_labels\": false\n      },\n      \"validations\": {\n        \"required\": false\n      }\n    },\n    {\n      \"title\": \"Rating Title\",\n      \"type\": \"rating\",\n      \"ref\": \"nice_readable_rating_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the rating\",\n        \"steps\": 10,\n        \"shape\": \"star\"\n      },\n      \"validations\": {\n        \"required\": false\n      },\n      \"attachment\": {\n        \"type\": \"video\",\n        \"href\": \"https://www.youtube.com/watch?v=Uui3oT-XBxs\",\n        \"scale\": 0.8\n      }\n    },\n    {\n      \"title\": \"Short Text Title\",\n      \"type\": \"short_text\",\n      \"ref\": \"nice_readable_short_text_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the short text\"\n      },\n      \"validations\": {\n        \"required\": false,\n        \"max_length\": 20\n      },\n      \"attachment\": {\n        \"type\": \"image\",\n        \"href\": \"https://images.typeform.com/images/4BKUhw8A9cSM\",\n        \"properties\": {\n          \"description\": \"A beautiful sunset\",\n          \"decorative\": false\n        }\n      }\n    },\n    {\n      \"title\": \"Statement Title\",\n      \"type\": \"statement\",\n      \"ref\": \"nice_readable_statement_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the statement\",\n        \"hide_marks\": true,\n        \"button_text\": \"Statement button text\"\n      },\n      \"attachment\": {\n        \"type\": \"video\",\n        \"href\": \"https://www.youtube.com/watch?v=Uui3oT-XBxs\",\n        \"scale\": 0.8\n      }\n    },\n    {\n      \"title\": \"Website Title\",\n      \"type\": \"website\",\n      \"ref\": \"nice_readable_website_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the website\"\n      },\n      \"validations\": {\n        \"required\": false\n      }\n    },\n    {\n      \"title\": \"yes or no\",\n      \"type\": \"yes_no\",\n      \"ref\": \"nice_readable_yes_no_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the Yes/No question\"\n      },\n      \"validations\": {\n        \"required\": false\n      },\n      \"attachment\": {\n        \"type\": \"image\",\n        \"href\": \"https://images.typeform.com/images/4BKUhw8A9cSM\",\n        \"properties\": {\n          \"decorative\": false\n        }\n      }\n    },\n    {\n      \"title\": \"payment\",\n      \"type\": \"payment\",\n      \"ref\": \"nice_readable_payment_reference\",\n      \"properties\": {\n        \"description\": \"Cool description for the payment group\",\n        \"button_text\": \"next\",\n        \"currency\": \"EUR\",\n        \"price\": {\n          \"type\": \"variable\",\n          \"value\": \"price\"\n        },\n        \"show_button\": true\n      },\n      \"validations\": {\n        \"required\": false\n      },\n      \"attachment\": {\n        \"type\": \"image\",\n        \"href\": \"https://images.typeform.com/images/4BKUhw8A9cSM\"\n      }\n    },\n    {\n      \"title\": \"group field\",\n      \"type\": \"group\",\n      \"ref\": \"a_group_field_ref\",\n      \"properties\": {\n        \"description\": \"Question group description\",\n        \"fields\": [\n          \"string\"\n        ],\n        \"button_text\": \"Some text\",\n        \"show_button\": true\n      },\n      \"attachment\": {\n        \"type\": \"image\",\n        \"href\": \"https://images.typeform.com/images/4BKUhw8A9cSM\"\n      }\n    },\n    {\n      \"title\": \"matrix field\",\n      \"type\": \"matrix\",\n      \"ref\": \"a_matrix_field_ref\",\n      \"properties\": {\n        \"description\": \"Matrix description\",\n        \"fields\": [\n          \"string\"\n        ]\n      }\n    },\n    {\n      \"title\": \"Contact info\",\n      \"type\": \"contact_info\",\n      \"ref\": \"a_contact_info_field_ref\",\n      \"properties\": {\n        \"fields\": [\n          \"string\",\n          \"string\",\n          \"string\",\n          \"string\",\n          \"string\"\n        ]\n      },\n      \"validations\": {\n        \"required\": false\n      }\n    }\n  ],\n  \"hidden\": [\n    \"var1\",\n    \"var2\",\n    \"var3\"\n  ],\n  \"logic\": [\n    {\n      \"type\": \"field\",\n      \"actions\": [\n        {\n          \"action\": \"jump\",\n          \"details\": {\n            \"to\": {\n              \"type\": \"field\",\n              \"value\": \"nice_readable_rating_reference\"\n            }\n          },\n          \"condition\
[...]
